OGRE: Ogre::RTShader::ProgramProcessor Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Classes | Public Member Functions | List of all members
Ogre::RTShader::ProgramProcessor Class Referenceabstract
Core » RTShader

A class that provides extra processing services on CPU based programs. More...

`#include <OgreShaderProgramProcessor.h>`

Inheritance diagram for Ogre::RTShader::ProgramProcessor:
[legend]

## Public Member Functions
| ProgramProcessor ()
| Class constructor. More...
virtual | ~ProgramProcessor ()
| Class destructor. More...
virtual const String & | getTargetLanguage () const =0
| Return the target language of this processor. More...
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual bool | postCreateGpuPrograms (ProgramSet *programSet)=0
| Called after creation of the GPU programs. More...
virtual bool | preCreateGpuPrograms (ProgramSet *programSet)=0
| Called before creation of the GPU programs. More...

## Detailed Description

A class that provides extra processing services on CPU based programs.

The base class perform only the generic processing. In order to provide target language specific services and optimization one should derive from this class and register its factory via the ProgramManager instance.

## Constructor & Destructor Documentation

## ◆ ProgramProcessor()

Ogre::RTShader::ProgramProcessor::ProgramProcessor | ( |  | ) |

Class constructor.

## ◆ ~ProgramProcessor()

virtual Ogre::RTShader::ProgramProcessor::~ProgramProcessor | ( |  | ) |
| virtual

Class destructor.

## Member Function Documentation

## ◆ getTargetLanguage()

virtual const String& Ogre::RTShader::ProgramProcessor::getTargetLanguage | ( |  | ) | const
| pure virtual

Return the target language of this processor.

Implemented in Ogre::RTShader::HLSLProgramProcessor, Ogre::RTShader::GLSLProgramProcessor, Ogre::RTShader::GLSLESProgramProcessor, and Ogre::RTShader::CGProgramProcessor.

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ postCreateGpuPrograms()

virtual bool Ogre::RTShader::ProgramProcessor::postCreateGpuPrograms | ( | ProgramSet * | programSet | ) |
| pure virtual

Called after creation of the GPU programs.

Parameters

  programSet | The program set container. Return true on success.

Implemented in Ogre::RTShader::HLSLProgramProcessor, Ogre::RTShader::GLSLProgramProcessor, Ogre::RTShader::GLSLESProgramProcessor, and Ogre::RTShader::CGProgramProcessor.

## ◆ preCreateGpuPrograms()

virtual bool Ogre::RTShader::ProgramProcessor::preCreateGpuPrograms | ( | ProgramSet * | programSet | ) |
| pure virtual

Called before creation of the GPU programs.

Do several preparation operation such as validation, register compaction and specific target language optimizations.

Parameters

  programSet | The program set container. Return true on success.

Implemented in Ogre::RTShader::HLSLProgramProcessor, Ogre::RTShader::GLSLProgramProcessor, Ogre::RTShader::GLSLESProgramProcessor, and Ogre::RTShader::CGProgramProcessor.

The documentation for this class was generated from the following file:

- OgreShaderProgramProcessor.h